\documentclass[../main.tex]{subfiles}
\graphicspath{{\subfix{../}}}

\begin{document}

\section{Technical Implementation of the KPI System}\label{sec:tech_imp}
In this section we present the final technical description of the system.

The ETC endorsed the use of Python as it is used in most shared EIDA software.
There are already Python libraries available in order to manage all the specificities of the project, in particular a stable implementation of the HyperLogLog algorithm~\parencite{python-hll}.
In order to implement the data model and store the values of the indicators, we chose PostgreSQL~\parencite{postgresql} relational database.
PostgreSQL is a well known software within the community and the implementation of HyperLogLog is provided by an extension postgres-hll~\parencite{postgres-hll}.

\subsection{Step 1: Local aggregation of data request logs}\label{sec:to_stat}

Each EIDA node produces an event log after each data request. This log contains information about the data delivered by the request, in a format that has been agreed on internally.
The Listing~\ref{code:datarequest} illustrates with an example the information extracted for each data request.

\begin{description}
\item[clientId] The user agent as given by the client. This allows to identify the program used to fetch data. This field is not used by the system (see Section~\ref{sec:cardinality});
\item[userLocation] The country where the request came from;
\item[bytes] The number of bytes delivered;
\item[trace] The source identifier of the data delivered (network, station, location, channel, start time, end time);
\item[status] The outcome of the request;
\item[finished] The time at which the request got fulfilled;
\item[userID] A user identifier generated by a hashing algorithm. See Section~\ref{sec:anonymise} for details.
\end{description}

The logs are accumulated in a file which can be processed by the local Aggregator program (see Figrure~\ref{fig:flowchart}),  provided by the project.

Values are aggregated with three parameters:
\begin{itemize}
  \item \texttt{month}: Date of the requests, truncated to the month as it is the time granularity specified for the project;
  \item \texttt{country}: The country code (ISO 3166-1) where the request comes from, based on the IP address; 
  \item Source identifier: \texttt{network}, \texttt{station}, \texttt{location}, \texttt{channel}.
\end{itemize}

When parsing the logs, the program produces the following values:

\begin{itemize}
  \item \texttt{successful requests}: the sum of requests returning data;
  \item \texttt{unsuccessful requests}: the sum of requests that did not return any data. This happens when a request is correctly specified but does not match any data.
  \item \texttt{unique clients}: the number of unique clients. This is an HyperLogLog set of the \texttt{userID} parameters;
  \item \texttt{size}: the sum of bytes distributed.
\end{itemize}

The aggregator also adds some metadata to its output (see example in Listing~\ref{code:aggr_metadata}).
At this stage the EIDA node is ready to ship the values to the central KPI system.
The overall workflow is illustrated in Figure~\ref{fig:flowchart}.
The aggregator was developed in the framework of the internal EIDA project eida-statistics~\parencite{eida-statistics}.

\begin{listing}
  \begin{minted}{json}
  {
    "clientID": "IRISDMC DataCenterMeasure/2019.136 Perl/5.018004",
    "finished": "2020-09-18T00:00:00.758768Z",
    "userLocation": {"country": "US"},
    "created": "2020-09-18T00:00:00.612126Z",
    "bytes": 98304,
    "service": "fdsnws-dataselect",
    "userEmail": null,
    "trace": [
      {
        "net": "GE", "cha": "BHZ", "loc": "", "sta": "EIL",
        "start": "1997-08-09T00:00:00.0000Z",
        "end": "1997-08-09T01:00:00.0000Z",
        "restricted": false,
        "bytes": 98304,
        "status": "OK"
      }
    ],
    "status": "OK",
    "userID": 1497164453
  }
  \end{minted}
  \caption{Example of information available at an EIDA node after each data delivery}\label{code:datarequest}
\end{listing}

\subsection{Step 2: Shipping aggregates to the central KPI service}\label{sec:interface}

As all EIDA nodes do not rely on the same implementation in order to serve the fdsnws-dataselect web service, the strategy consisted of defining the interaction between the EIDA nodes and the central system. 
Each EIDA node is responsible for providing the logging aggregates in a given format through an agreed protocol. 
For the latter, HTTP was chosen because it is well suited and well known by the community.
The ETC approved to ship the data from each EIDA node as a JSON file, optionally compressed using gzip.
The aggregated JSON file contains a list of indicator values along with some metadata that are useful for the central system to store them: the version of the aggregator program, the list of days covered by the indicators.
An example of this metadata is provided in Listing~\ref{code:aggr_metadata}.

\begin{listing}
    \centering
    \begin{minted}{json}
    {
       "generated_at": "2022-09-10 00:00:00",
       "version": "1.0.3",
       "days_coverage": ["2022-09-09"]
       "stats": []
    }
    \end{minted}
    \caption{Metadata provided by each EIDA node in the JSON format}\label{code:aggr_metadata}
\end{listing}

\subsection{Step 3: Ingesting aggregates}\label{sec:tech-step3}

The central database stores the data shipped by the nodes.
The data model in the central database is tightly linked to the data structure that the aggregator program provides, illustrated in Figure~\ref{fig:datamodel}.
The ingestion mechanism can be decomposed into three steps:

\begin{enumerate}

\item Before its first submission, each EIDA node was provided with an authentication token from the central database operator, with which it can submit a payload (the output of the aggregator program).
\item On the server side, the token used in the submission request allows to identify the EIDA node.
Commonly, nodes push their usage aggregates on a daily or weekly basis.
All payloads are aggregated again by month, source identifiers and EIDA node.

\item A hash of the payload is computed and kept in the database in order to avoid ingesting twice the same payload.
This is a simple approach guarding against duplication errors on the EIDA node side and is efficient in our context where all the EIDA nodes are part of a trusted group.
\end{enumerate}

\begin{figure}[ht]
  \centering
  \includegraphics[width=12cm]{images/fig04.png}
  \caption{\label{fig:datamodel} Data model of the KPI database.}
\end{figure}

The project eida-statistics~\parencite{eida-statistics} contains the database back end and a web service to ingest payloads.
The web service specifications are publicly available and documented\endnote{See the \texttt{POST /eidaws/statistics/1/submit} at \url{https://ws.resif.fr/eidaws/statistics/1}}.

\subsection{Aggregates coverage in central database}\label{sec:coverage}

In order to provide trustworthy values, it is important to ensure that a representative amount of numbers have been collected to the central database.
The coverage of a node is the percentage of days having KPI values over a time period.
This metric is built and stored in the central database during the ingestion process, on a daily granularity.

The central database operator and all participants can access to the coverage score of the nodes through a private dashboard web interface powered by Grafana~\parencite{grafana} and hosted at the Observatoire des Sciendes de l'Univers of Grenoble~\parencite{OSUG}.
It is in practice a handy tool to identify problems between the nodes and the central database.
Figure~\ref{fig:coverage} illustrates a view of the KPI coverage for several month for some of the EIDA nodes.
This view show how a node's operator or the EMB can have a quick and efficient estimate of the completeness of the indicators.

\begin{figure}[ht]
  \centering
  \includegraphics[width=12cm]{images/fig05.png}
  \caption{\label{fig:coverage} Example of a view for EIDA nodes operators, \added{presenting monthly KPI coverage} for four of the 12 EIDA nodes at June 2023. The coverage for June is not complete because it is the ongoing month. }
\end{figure}

\subsection{Managing indicator access restrictions}

Due to the requirement of the project, a restricted access to indicators had to be implemented for specific seismic networks, as stated in Section~\ref{sec:kpiopenness}.
Authentication relies on EIDA authentication system\endnote{EAS:\@\url{https://geofon.gfz-potsdam.de/eas/}} which is commonly used in the community.
Authorisation management is based on B2Access groups\endnote{B2Access:\@\url{https://eudat.eu/catalogue/b2access}}.
In the EIDA KPI database, each network has a restriction policy and the name of the B2Access group authorised to access the values.
With this technical choice the project avoids to manage individual accounts and associated GDPR issues.

\subsection{Accessing the indicators values}\label{sec:values_access}

The project provides an API to request KPI values in a form that facilitates a client-side exploration interface.

This API can be used directly for creating customized plots. We provide some examples to illustrate the possibilities in Figures~\ref{fig:generatedfigs} and~\ref{fig:chloropleth}.
Figure~\ref{fig:generated_plot} shows data delivery for AlpArray across EIDA nodes, generated with a simple Python script (see Listing~\ref{algo:plotly-example}). For the plots in Figure~\ref{fig:generatedfigs}, we also provide sources{\endnote{The source code for generating graphics by using the statistics API is provided as an orgmode file at \url{https://gitlab.com/resif/publications/eida-kpi/-/blob/31258bb03b831473fe520bac709cfcc1c4b2dda3/libs/dashboard.org}.}}.

Finally, EIDA developed a graphical dashboard~\parencite{statsboard} using the API.
This web user interface exposes the parameters to request the statistics API and generates figures.
The dashboard is now available for public consultation on the ORFEUS portal\endnote{Statistics board on the ORFEUS portal \url{https://orfeus-eu.org/data/eida/stats/}`}. Figure~\ref{fig:dashboard} shows some screenshots of the dashboard.

Both dashboard and backend API are developed in a tight collaboration between the development team and representatives of the different target user groups (see Section~\ref{sec:define_stats}).

\begin{figure}
  \begin{subfigure}{\textwidth}
    \centering
    \includegraphics[width=11cm]{images/fig06a.png}
    \caption{\label{fig:users_eida}}
  \end{subfigure}
  \begin{subfigure}{\textwidth}
    \centering
    \includegraphics[width=11cm]{images/fig06b.png}
    \caption{\label{fig:req_eida}}
  \end{subfigure}
  \begin{subfigure}{\textwidth}
    \centering
    \includegraphics[width=11cm]{images/fig06c.png}
    \caption{\label{fig:vols_eida}}
  \end{subfigure}
  \caption{\label{fig:generatedfigs}Examples of figures generated programmatically using the web API, illustrating three monthly KPI across EIDA between June 2022 and November 2023.\ \ref{fig:users_eida} shows unique users,\ \ref{fig:req_eida} shows data requests (successful and unsuccessful),\ \ref{fig:vols_eida} shows the volumes of data delivered.}
\end{figure}

\begin{figure}
  \begin{subfigure}{\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/fig07a.png}
    \caption{\label{fig:chloropleth:a}}
  \end{subfigure}
  \hfill
  \begin{subfigure}{\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/fig07b.png}
    \caption{\label{fig:chloropleth:b}}
  \end{subfigure}
  \caption{\label{fig:chloropleth} Figures showing worldwide repartition of some KPIs in 2022. Figure~\ref{fig:chloropleth:a} is the volume of distributed data and Figure~\ref{fig:chloropleth:b} is the number of clients. Similar figures can be produced via the API, for example using the code snippet at \url{https://gitlab.com/-/snippets/2529969} }
\end{figure}
\begin{figure}
    \centering
    \includegraphics[width=\textwidth]{images/fig08.png}
    \caption{Cumulated data delivery for AlpArray across EIDA nodes using EIDA's statistics web service. AlpArray data is distributed across 6 EIDA nodes. Figure produced by the code in Listing~\ref{algo:plotly-example} using the statistics API.}\label{fig:generated_plot}
\end{figure}

\begin{listing}
    \centering
    \begin{minted}[breaklines]{python}
import requests
import plotly.express as px
baseurl = "https://ws.resif.fr/eidaws/statistics/1/dataselect/public"
query = "start=2021-06&end=2023-05&level=node&network=Z32015&details=month&format=json"
stats = requests.get(f"{baseurl}?{query}").json()
fig = px.bar(stats['results'], x="date", y='bytes',
      title="""Data distributed for AlpArray (Z3_2015) across all EIDA nodes. Embargo ends in April 2022.""",
      width=1200, height=600,
      color='node', color_discrete_sequence=px.colors.sequential.Viridis_r)
fig.show()
    \end{minted}
    \caption{Example program producing Figure~\ref{fig:generated_plot} using the plotly library~\parencite{plotly}, Code available as snippet at \url{https://gitlab.com/-/snippets/2530688}}\label{algo:plotly-example}
\end{listing}

\begin{figure}
  \begin{subfigure}{\textwidth}
    \centering
    \includegraphics[width=13cm]{images/fig09a.png}
    \caption{\label{fig:dashboard:a}}
  \end{subfigure}
  \begin{subfigure}{\textwidth}
    \centering
    \includegraphics[width=13cm]{images/fig09b.png}
    \caption{\label{fig:dashboard:b}}
  \end{subfigure}
  \begin{subfigure}{\textwidth}
    \centering
    \includegraphics[width=12cm]{images/fig09c.png}
    \caption{\label{fig:dashboard:c}}
  \end{subfigure}
  \caption{\label{fig:dashboard}Screenshots of the dashboard. Figure~\ref{fig:dashboard:a} is a view where the user can select time spans, level of visualisation and narrow down to node or networks. It is also possible to provide a token in order to be authenticated and access indicators for networks with restricted KPI access. Figure~\ref{fig:dashboard:b} is a screenshot of one of the possible graphical visualisations provided by the web interface. Figure~\ref{fig:dashboard:c} is a screenshot of another possible visualisation (pie chart)}
\end{figure}

\end{document}

%%% Local Variables:
%%% mode: latex
%%% ispell-local-dictionary: en_GB
%%% End:
